using System;

class MainClass {
  
    // Matkimme nyt struct-tietuetta luokalla,
    // mutta oikeasti _EI_KOSKAAN_ laiteta
    // vain public attribuutteja luokkaan,
    // vaan attribuutit ovat aina privateja
    // ja metodit hoitavat tiedon käsittelyn.
    class Luku  {
        public int Arvo;
        public Luku Seuraava;
    };

    static Luku Lisaa(Luku lukujono, int arvo) {
        Luku uusi = null;
        uusi = new Luku();
        uusi.Arvo = arvo;
        uusi.Seuraava = lukujono;
        return uusi;
    }

    static void Tyhjenna(Luku lukujono) {
        if (lukujono == null) return;
        Luku seuraava = lukujono.Seuraava;
        lukujono.Seuraava = null;
        Tyhjenna(seuraava);
    }

    static int SeuraavaFibo(int eka, int toka) {
        return eka + toka;
    }

    static Luku LaskeFibo(Luku lukujono, int lkm) {
        for (int i=0; i < lkm; ++i) {
            int e = lukujono.Arvo;
            int ee = lukujono.Seuraava.Arvo;
            int uusi = SeuraavaFibo(ee, e);
            lukujono = Lisaa(lukujono, uusi);
        }

        return lukujono;
    }

    static void TulostaLuvut(Luku lukujono) {
        Luku nykyinen = lukujono;
        if (nykyinen == null) return;

        TulostaLuvut(nykyinen.Seuraava);
        Console.WriteLine(nykyinen.Arvo);
    }

    public static int Main (string[] args) {
        Luku lukujono = Lisaa(null, 1);
        if (args.Length != 1){
            Console.WriteLine("Tarvitsen printattavien lukujen lukumäärän!\n");
            return 1;
        }
        int lkm = Int32.Parse(args[0]);
  
        lukujono = Lisaa(lukujono, 1);
        lukujono = LaskeFibo(lukujono, lkm);
        TulostaLuvut(lukujono);
        Console.WriteLine();
        Tyhjenna(lukujono);
        return 0;
    }
}
